<?php
/**
 *
 * This Dashboard plugin lets you login into your Google Analytic account.
 * and gets visitors and pageview information from the last x given days. 
 *
 * The GAConnect class (originaly call GoogleAnalytics) is from Doug Tan (see class for more info)
 * I renamed the classname to avoid conflicts with the Google Analytics class from Sam Minne
 *
 *
 * @author Martijn van Nieuwenhoven
 * @email info@axyrmedia.nl
 *
 * @todo a lot :) Google Analytics Api provides a lot of information to present.
 * @todo some fancy ajax calls to generate reports in one Plugin position.
 * @todo add custom CSS
 * @todo i18n strings
 * @todo don't forget there is lunch sometimes...
 *
 * @version 0.1 initial release
 *
 * Usage
 * Provide emailadres, password from your Google Analytics account 
 * Provide your report ID
 * see here how to get the report id : 
 * http://www.electrictoolbox.com/get-id-for-google-analytics-api/
 *
 * Have fun, more will come soon :)
 * O, and no. I'm not responsible in any way for any unwanted sideeffects caused by this code.
 *
 */

class GAStats extends DashboardPlugin {
	static $position	 = "snippet";
	static $sort 		 = 0;
	static $title 		 = "Google Analytics";
	static $link 		 = "https://www.google.com/analytics/reporting/";
	static $icon 		 = "dashboard/code/dashboard_plugins/gastats/images/google_icon.png";
	static $null_message = 'login failed';
	
	static $id			 = 'id'; //http://www.electrictoolbox.com/get-id-for-google-analytics-api/
	static $username 	 = 'youremail@gmail.com';
	static $password 	 = 'password';
	static $days		 = 14;
	
	// login 
	protected function ga(){
		return new GAConnect(self::$username,self::$password);
	}
	
	public function Report() {
		
		Requirements::css('dashboard/code/dashboard_plugins/gastats/css/style.css');
	
		$ga = self::ga();
		// set the Google Analytics profile you want to access - format is 'ga:123456';
		$ga->setProfile('ga:'.self::$id);
	
		// set the date range we want for the report - format is YYYY-MM-DD
		$today = date('Y-m-d');
		$lastweek = date('Y-m-d',strtotime(date("Y-m-d", strtotime($today)) . " -".self::$days." day"));
	
		$ga->setDateRange($lastweek,$today);
	
		// get the report for date and country filtered by Australia, showing pageviews and visits
		$report = $ga->getReport(
			array('dimensions'=>urlencode('ga:date'),
				'metrics'=>urlencode('ga:pageviews,ga:visits'),
				'sort'=>'-ga:date'
				)
			);
		
		$output = new DataObjectSet();
	
		foreach($report as $key => $value){
			
			$date = date('d-m-Y',strtotime($key));
			
			$output->push(new ArrayData(array(
					'date'	=> $date,
					'pageviews'	=> $value['ga:pageviews'],
					'visits'	=> $value['ga:visits']
				)));
		}

		return $output;
		
	}
}